<?php
namespace BackOfficeOptimizer\Libraries; 

use BackOfficeOptimizer\Libraries\JWT;
class PermissionManager{

    const permissions = [
        "delete" => [
            "1" => [],
            "2" => ["PRODUTOGRUPOPRATORESTRICACAO", "VIGENCIAPRODUTOGRUPOPRATORESTRICACAO"],
            "3" => ["UTILIZACAOPRATOSEMANA", "VIGENCIAUTILIZACAOPRATOSEMANA"],
            "4" => ["FREQUENCIAGRUPOPRATOPRODUTO", "VIGENCIAGRUPOPRATOPRODUTO"],
            "5" => ["FREQUENCIAGRUPO", "VIGENCIAGRUPOPRATO"],
            "6" => ["FREQUENCIAPRATO", "VIGENCIAPRATO"],
            "7" => [],
            "8" => [],
            "9" => [],
            "10" => ["COMBGRUPOTPPRAT"],
            "11" => ["INGRPRINC"],
            "12" => ["ATRATIVIDADE"],
            "13" => ["MDPREPARO"],
            "14" => ["TPCORTE"],
            "15" => [],
            "16" => [],
            "17" => ["GROUP_PLATE_PLT", "PLATE_GROUP"],
            "18" => [],
            "19" => ["AGRUPGRPRAT"],
            "20" => ["PADGRUPOPRATO"],
            "21" => [],
            "22" => [],
            "24" => ["PORTIONING_SET"],
            "25" => [],
            "26" => ["TIPO_PRATO_REGRAS_RESTRICAO_REPETICAO", "INGREDIENTE_REGRAS_RESTRICAO_REPETICAO", "REGRAS_RESTRICAO_REPETICAO"],
            "27" => ["MONTH_SERVCONFIG_PERC_SOURCE"],
            "28" => ["DAYS_EVENT_OUT_OF_RUT", "DELETE_DAYS_OUT_RUT_OVERLAP"],
            "29" => ["LINK_TYPE_DISHES_BETWEEN_SERVICES"],
            "NOCHECK" => []
            // "COMBRESTR ????"
        ],
        "insert" => [
            "1" => [],
            "2" => ["PRODUTOGRUPOPRATORESTRICACAO", "VIGENCIAPRODUTOGRUPOPRATORESTRICACAO"],
            "3" => ["UTILIZACAOPRATOSEMANA", "VIGENCIAUTILIZACAOPRATOSEMANA"],
            "4" => ["FREQUENCIAGRUPOPRATOPRODUTO", "VIGENCIAGRUPOPRATOPRODUTO"],
            "5" => ["FREQUENCIAGRUPO", "VIGENCIAGRUPOPRATO"],
            "6" => ["FREQUENCIAPRATO", "VIGENCIAPRATO"],
            "7" => [],
            "8" => [],
            "9" => ["PARAMPRATGRUPPRAT"],
            "10" => ["COMBGRUPOTPPRAT"],
            "11" => ["INGRPRINC"],
            "12" => ["ATRATIVIDADE"],
            "13" => ["MDPREPARO"],
            "14" => ["TPCORTE"],
            "15" => ["CONSUMPTION_HISTORY"],
            "16" => [],
            "17" => ["NEW_PLATE", "PLATE_GROUP"],
            "18" => ["PRATOSEMGRUPO"],
            "19" => ["AGRUPGRPRAT"],
            "20" => ["PADGRUPOPRATO"],
            "21" => ["CENARIO"],
            "22" => [],
            "24" => ["PORTIONING_SET"],
            "25" => [],
            "26" => ["REGRAS_RESTRICAO_REPETICAO", "TIPO_PRATO_REGRAS_RESTRICAO_REPETICAO", "INGREDIENTE_REGRAS_RESTRICAO_REPETICAO"],
            "27" => ["MONTH_SERVCONFIG_PERC_SOURCE"],
            "28" => ["DAYS_EVENT_OUT_OF_RUT","INSERT_EXPORT_DATA_DAY_OUT_RUT"],
            "29" => ["LINK_TYPE_DISHES_BETWEEN_SERVICES"],
            "30" => [],
            "NOCHECK" => []
            // NEED GRANT_ALL: "ACCESS_PROFILE_PERMISSION"
        ],
        "find" => [
            "1" => ["DESCOBSFILIAL"],
            "2" => ["GRUPOPRATO_AUTOCOMPLETE", "PRODUTOGRUPOPRATORESTRICACAO", "VIGENCIAPRODUTOGRUPOPRATORESTRICACAO", "PRODUTO_AUTOCOMPLETE", "DESCOBSFILIAL"],
            "3" => ["DESCOBSFILIAL", "VIGENCIAUTILIZACAOSEMENA", "UTILIZACAOPRATOSEMANA", "GRUPO_NAO_PARAMETRIZADO_UTILIZACAO_SEMANA"],
            "4" => ["GRUPOPRATO_AUTOCOMPLETE", "DESCOBSFILIAL", "VIGENCIAGRUPOPRATOPRODUTO", "FREQUENCIAGRUPOPRATOPRODUTO", "PRODUTO_AUTOCOMPLETE"],
            "5" => ["DESCOBSFILIAL", "VIGENCIAGRUPOPRATO", "FREQUENCIAGRUPO", "GRUPOPRATOSERV_AUTOCOMPLETE"],
            "6" => ["DESCOBSFILIAL", "VIGENCIAPRATO", "FREQUENCIAPRATO", "PRATO_NAO_PARAMETRIZADO_FREQ"],
            "7" => [],
            "8" => [],
            "9" => ["PARAMPRATO", "GRUPOPRAT", "INGRPRINC", "TPCORTE", "MDPREPARO", "ATRATIVIDADE", "SIMILAR_PLATES"],
            "10" => ["GRUPOTIPOPRATO_AUTOCOMPLETE", "COMB_GRUPOTIPOPRATO_AUTOCOMPLETE", "PRATO", "COMB_PRATO", "COMBGRUPOTPPRAT", "PRATO_GRUPO", "GRUPO_PRATO_AUTOCOMPLETE", "TIPOPRATO_AUTOCOMPLETE"],
            "11" => ["INGRPRINC"],
            "12" => ["ATRATIVIDADE"],
            "13" => ["MDPREPARO"],
            "14" => ["TPCORTE"],
            "15" => ["CONSUMPTION_HISTORY", "PRATO_HIST_CONSUMO","CONSUMPTION_HISTORY_INTERVAL"],
            "16" => [],
            "17" => ["PLATEGROUPS", "GROUPSET_TO_ADD", "GROUPS_TO_ADD", "PLATES_BY_GROUP", "PLATE_RECIPE", "PLATES_TO_ADD"],
            "18" => ["PRATOSEMGRUPO"],
            "19" => ["AGRUPGRPRAT"],
            "20" => ["PADGRUPOPRATO"],
            "21" => ["CENARIOWOJ", "CENARIO", "TIPOCUSTO", "TIPOCUSTO_SEARCH", "DEFAULTOPTDATA", "PERMITECONGELAR", "AGUPAMENTO_FILIAL", "SERVICOS_AUTOCOMPLETE", "FILIAL_AUTOCOMPLETE", "SERVICO_AUTOCOMPLETE_DEFAULTCARD_DATA"],
            "22" => ["CENARIOWOJ", "CENARIO", "TIPOCUSTO", "TIPOCUSTO_SEARCH", "DEFAULTOPTDATA", "PERMITECONGELAR"],
            "24" => ["PORTIONING_SET", "GRUPOTIPOPRATO_NOT_IN_PORTIONING_SET"],
            "25" => ["SERVCONFIG"],
            "26" => ["REGRAS_RESTRICAO_REPETICAO", "TIPOPRATO_POR_REGRAS_RESTRICAO", "TIPOPRATO_POR_REGRAS_RESTRICAO_AUTOCOMPLETE", "INGREDIENTE_REGRAS_RESTRICAO", "INGREDIENTE_REGRAS_RESTRICAO_AUTOCOMPLETE"],
            "27" => ["MONTHSERVCONFIG"],
            "28" => ["DAYS_EVENT_OUT_OF_RUT"],
            "29" => ["LINK_TYPE_DISHES_BETWEEN_SERVICES", "DESTINE_DISHES", "ORIGIN_DISHES","ORIGIN_SERVICE"],
            "30" => ["GETBATCH", "GETBATCHSCENARIO", "GETGENERATIONSUMMARY", "GETPUBLICATIONSUMMARY", ],
            "NOCHECK" => ["FILIAL", "SERVICOS", /*??*/"COMBRESTR", "GRUPOTIPOPRATO", "VINGENCIASOBRIG", "OBRIGATORIEDADE", "AGRUPFILI", "FILIAGRUP","SERVFILIAGRUP", "TIPOCUSTO", "TIPOCUSTOPLA", "GRUPPROD", "AGRUPPROD", "GRUPPROD_PARAMGERAL", "CENARIOVINCULO", "CENARIOPUBLICAR", "CABECALHOEXPORTLOG", "GENERATIONALERT", "LINKEDSERVICE","FILIAL_FILIOPER","SERVICE_FILIOPER","GET_GROUP_PRAT","GET_MULTI_GROUP_PRAT","GET_VALIDITY","GET_CDGRUPPROD_PARAMGERAL","GET_CDGRUPPROD","GET_LINK_COMMON_DISHES"]
            //NEED GRANT_ALL: ACCESS_PROFILE","ACCESS_PROFILE_PERMISSION","USERS_BY_ACCESS_PROFILE"
        ],
        "update" => [
            "1" => [],
            "2" => ["VIGENCIAPRODUTOGRUPOPRATORESTRICACAO"],
            "3" => ["UTILIZACAOPRATOSEMANA", "VIGENCIAUTILIZACAOPRATOSEMANA"],
            "4" => ["FREQUENCIAGRUPOPRATOPRODUTO", "VIGENCIAGRUPOPRATOPRODUTO"],
            "5" => ["FREQUENCIAGRUPO", "VIGENCIAGRUPOPRATO"],
            "6" => ["FREQUENCIAPRATO", "VIGENCIAPRATO"],
            "7" => [],
            "8" => [],
            "9" => ["PARAMPRAT", "PARAMPRATGRUPPRAT"],
            "10" => ["COMBGRUPOTPPRAT"],
            "11" => ["INGRPRINC"],
            "12" => ["ATRATIVIDADE"],
            "13" => ["MDPREPARO"],
            "14" => ["TPCORTE"],
            "15" => ["HISTATRATIVIDADE", "CONSUMPTION_HISTORY"],
            "16" => ["CONSUMPTION_HISTORY"],
            "17" => ["PLATE_GROUP"],
            "18" => [],
            "19" => ["AGRUPGRPRAT"],
            "20" => ["PADGRUPOPRATO"],
            "21" => [],
            "22" => [],
            "24" => ["PORTIONING_SET", "PORTIONING_SET_CALCULATE_CONSUMPTION_PERCENTAGE"],
            "25" => ["SERVCONFIG", "SERVCONFIG_PERC_SOURCE"],
            "26" => ["INGREDIENTE_REGRAS_RESTRICAO_REPETICAO", "REGRAS_RESTRICAO_REPETICAO"],
            "27" => ["MONTH_SERVCONFIG_PERC_SOURCE"],
            "28" => ["DAYS_EVENT_OUT_OF_RUT"],
            "29" => [],
            "30" => ["UPDATE_STATUS_ITEMS", "UPDATESTATUSITGERACAOCARD"],
            "NOCHECK" => ["ASSOSGRUPTIPOPRATO, REMASSOSGRUPTIPOPRATO"]
        ]
    ];

    private static function _findInPermissionsArray($permissions, $lookupValue){
        $scopeIDS = [];
        foreach($permissions as $scopeID => $p){
            if(in_array($lookupValue, $p)){
                $scopeIDS[] = $scopeID;
            }
        }
        return $scopeIDS;
    }

    public static function userHasPermissionTo ($operation, $routeName, $token){
        $permissionGranted = false;
        $operations = ["find", "insert", "update", "delete"];
        if(in_array($operation, $operations)){
            $userInfo = JWT::getTokenData($token);
            if($userInfo["GRANT_ALL"] || in_array($routeName, self::permissions[$operation]["NOCHECK"])){
                $permissionGranted = true;
            } else {
                $scopeIDS = self::_findInPermissionsArray(self::permissions[$operation], $routeName);
                $permissionGranted = !empty(array_intersect($scopeIDS, $userInfo["SCOPES"]));
            }
        } else {
            $permissionGranted = false; //invalid operation
        }

        return $permissionGranted;
    }
}