<?php
namespace BackOfficeOptimizer\Providers;

use Zeedhi\Framework\DataSource\DataSet;

class LoginProvider{
    protected $connection;

    public function __construct($connection){
        $this->connection = $connection;
    }

    public function login($userData, $loginType){
        $sql = $this->getSql($loginType);
 
        $params = array(
            "DSEMAILOPER"=> $userData->get('username'),
            "CDSENHAOPERWEB"=> $userData->get('password'),
            "NRORG"=> $userData->has('nrorg') ? $userData->get('nrorg') : null,
            "CDOPERADOR"=> $userData->has('usercode') ? $userData->get('usercode') : null
        );

        if($loginType == 'username'){
            unset($params['DSEMAILOPER']);
            $params['NMACESSO'] =  $userData->get('username');
        }
  
        $statement = $this->connection->prepare($sql); 
        $statement->execute($params);   
        
        return $statement->fetchAll();
    }
    
    public function getSql($loginType){
        if($loginType == 'username'){
            return "SELECT O.DSEMAILOPER, O.NMOPERADOR, O.CDOPERADOR, O.CDFILIALSELECIONADA, O.NRORG, O.DSIMAGEMOPER, F.NMFILIAL FROM OPERADOR O, FILIAL F WHERE F.CDFILIAL (+) = O.CDFILIALSELECIONADA AND NMACESSO =:NMACESSO AND CDSENHAOPERWEB =:CDSENHAOPERWEB AND IDOPERATIVO = 'A' AND NVL(:NRORG,O.NRORG) = O.NRORG AND NVL(:CDOPERADOR,O.CDOPERADOR) = O.CDOPERADOR";
        }
        
        return "SELECT O.DSEMAILOPER, O.NMOPERADOR, O.CDOPERADOR, O.CDFILIALSELECIONADA, O.NRORG, O.DSIMAGEMOPER, F.NMFILIAL FROM OPERADOR O INNER JOIN FILIAL F ON F.CDFILIAL (+) = O.CDFILIALSELECIONADA WHERE DSEMAILOPER =:DSEMAILOPER AND CDSENHAOPERWEB =:CDSENHAOPERWEB AND O.IDOPERATIVO = 'A' AND NVL(:NRORG,O.NRORG) = O.NRORG AND NVL(:CDOPERADOR,O.CDOPERADOR) = O.CDOPERADOR";
    }
    
}
