<?php
namespace BackOfficeOptimizer\Services;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use BackOfficeOptimizer\Libraries\JWT;
use BackOfficeOptimizer\Libraries\ConnectionCustom;
use Doctrine\ORM\EntityManager as EntityManager;

class Login {
    protected $entityManager;
    protected $loginProvider;
    protected $paramGeralProvider;
    protected $environment;
    protected $permissionProvider;
    protected $connectionCustom;
    protected $fileServerFilesPath;

    public function __construct($entityManager, $loginProvider, $paramGeralProvider, $environment, $permissionProvider, $connectionCustom, $fileServerFilesPath){
        $this->entityManager = $entityManager;
        $this->loginProvider = $loginProvider;
        $this->paramGeralProvider = $paramGeralProvider;
        $this->environment = $environment;
        $this->permissionProvider = $permissionProvider;
        $this->connectionCustom = $connectionCustom;
        $this->fileServerFilesPath = $fileServerFilesPath;
    }

    public function doLogin(Request $request, Response $response){ 
        $row = $request->getRow();

        $email = filter_var($row['username'], FILTER_VALIDATE_EMAIL);
   
        if($email){
            $user = $this->loginProvider->login($row, 'email');

        }else{
            $user = $this->loginProvider->login($row, 'username');
        }

        if (!empty($user)) {
           $newConnection = $this->connectionCustom->updateVpdConnection($user[0]['NRORG']);

            if ($newConnection) {
                $this->entityManager = $newConnection;

                if($email){
                    $user = $this->loginProvider->login($row, 'email');

                }else{
                    $user = $this->loginProvider->login($row, 'username');
                }
        
            }
        }
        
        $fileServerFilesPath = $this->fileServerFilesPath;
        if(strpos($fileServerFilesPath, '/files/files/') !== false){
            $fileServerFilesPath = str_replace  ('/files/files/', '', $this->fileServerFilesPath)."/files";
        }
       
        if($user && sizeof($user)){
           if(!empty($newConnection)){
                $connection = $newConnection->getConnection();
                $this->paramGeralProvider->setConnection($connection); 
                $this->permissionProvider->setConnection($connection);
            }
                   
            $per = $this->permissionProvider->getUserPermissions($user[0]['CDOPERADOR'], $user[0]['NRORG']);
   
            $token = JWT::generateToken(array(
                "CDOPERADOR" => $user[0]['CDOPERADOR'],
                "NRORG" => $user[0]['NRORG'],
                "GRANT_ALL" => $per["grantAll"],
                "SCOPES" =>  $per["scopes"],
                "fileServiceFilesPath" => $fileServerFilesPath
            ));
             
            JWT::setSessionCookie("optimizer", $token);
            
            $paramGeralData = $this->paramGeralProvider->getParamGeral($row);
            
            $response->addDataSet(new DataSet('canAccessPermissionManagement', [$per["canAccessPermissionManagement"]]));
            $response->addDataSet(new DataSet('paramGeralData', $paramGeralData));
            $response->addDataSet(new DataSet('token', [$token]));
            $response->addDataSet(new DataSet('permissions', $per));
            $response->addDataSet(new DataSet('loginData', $user));
        }
    }
    
    public function testConnection(){}
}
